## lava 2020.12

=== doc/v2/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    = -n -j 4 -W
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

check:
	@if (find . -name '*.rst' | xargs grep -E '\.\.[a-z]+:'); then \
		echo broken sphinx directive\(s\) found - see above ; \
		false ; \
	else \
		true; \
	fi

clean:
	-rm -rf $(BUILDDIR)/*

html: check
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	cp -R examples/ $(BUILDDIR)/html/
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/LavaDispatcher.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/LavaDispatcher.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/LavaDispatcher"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/LavaDispatcher"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== debian/changelog ===
lava (2020.12-5+deb11u2) bullseye-security; urgency=high

  * Prevent Recursive XML entity expansion [CVE-2022-44641] (Closes: #1024429)
  * debian/tests/testsuite: ignore tests/lava_dispatcher/test_compression.py
    and tests/lava_dispatcher/test_defs.py. They both fail on bullseye, but
    pass on bookworm.

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 11 Jan 2023 15:08:56 -0300

lava (2020.12-5+deb11u1) bullseye-security; urgency=high

  * Fix remote code execution [CVE-2022-42902] (Closes: #1021737)
  * Add patch to fix building the package for -security

 -- Antonio Terceiro <terceiro@debian.org>  Tue, 18 Oct 2022 17:24:50 -0300

lava (2020.12-5) unstable; urgency=medium

  * Fix PyYAML usage after backwards-incompatible security update
    (Closes: #988998)

 -- Antonio Terceiro <terceiro@debian.org>  Mon, 24 May 2021 09:05:18 -0300

lava (2020.12-4) unstable; urgency=medium

  * Reinstate /etc/logrotate.d/lava-scheduler-log with the original contents
    from stretch on upgrades from buster if the file was installed by the
    version in stretch. That file has been deprecated in the last version in
    buster, but it wasn't removed correctly. (Closes: #988362)

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 12 May 2021 10:34:00 -0300

lava (2020.12-3) unstable; urgency=medium

  * Drop possible celery backends from Recommends.
  * Re-add debian/patches/0001-lava_rest_app-fix-field-name-in-filters.patch;
    dropped by mistake. (Closes: #984496)

 -- Antonio Terceiro <terceiro@debian.org>  Thu, 04 Mar 2021 08:52:38 -0300

lava (2020.12-2) unstable; urgency=medium

  * debian/rules: drop jquery.flot.canvas.js.
    This fixes gunicorn not starting due to the jquery.flot.canvas.js
    pointing to a missing file. The entire charts feature will not work,
    since lava upstream hasn't upgraded to flot 4. (Closes: #983029)

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 03 Mar 2021 11:54:11 -0300

lava (2020.12-1) unstable; urgency=medium

  * LAVA Software 2020.12 release
    - Contains fix for Python error causing a failure to install
      (Closes: #974745)

  [ Kumar Gala ]
  * lava_dispatcher_host: Utilize pyudev to share devices

  [ Antonio Terceiro ]
  * debian/patches/0001-lava_rest_app-fix-field-name-in-filters.patch: fix for
    django-filter 2.4.0

 -- Remi Duraffort <remi.duraffort@linaro.org>  Thu, 10 Dec 2020 17:28:16 +0100

lava (2020.10-1) unstable; urgency=medium

  * LAVA Software 2020.10 release

  [ Rémi Duraffort ]
  * Add lava-celery-worker and add celery requirement
  * debian: do not activate lava-celery-worker service by default

 -- Remi Duraffort <remi.duraffort@linaro.org>  Mon, 02 Nov 2020 09:02:37 +0100

lava (2020.09-1) unstable; urgency=medium

  * LAVA Software 2020.09 release

  [ Rémi Duraffort ]
  *  worker: replace lava-slave by lava-worker
  *  Replace lava-master and lava-logs by lava-scheduler
  *  Drop create_certificate
  *  debian/lava-server: drop dependency on iproute2
  * Fix debian changelog

  [ Antonio Terceiro ]
  *  lava-dispatcher-host: add missing dependency
  *  lava-dispatcher-host: provide lava-docker-worker service definition

 -- Remi Duraffort <remi.duraffort@linaro.org>  Thu, 01 Oct 2020 10:07:53 +0200

lava (2020.08-1) unstable; urgency=medium

  * LAVA Software 2020.08 release

  [ Antonio Terceiro ]
  * debian: bump debhelper compat level to 12
  * autopkgtest: fix against change in settings

 -- Remi Duraffort <remi.duraffort@linaro.org>  Thu, 20 Aug 2020 10:58:25 +0200

lava (2020.07-1) unstable; urgency=medium

  * LAVA Software 2020.07 release

 -- Stevan Radakovic <stevan.radakovic@linaro.org>  Thu, 09 Jul 2020 16:58:12 +0200

=== debian/control ===
Source: lava
Section: net
Priority: optional
Maintainer: Debian LAVA team <pkg-linaro-lava-devel@lists.alioth.debian.org>
Uploaders: Antonio Terceiro <antonio.terceiro@linaro.org>,
           Remi Duraffort <remi.duraffort@linaro.org>
Build-Depends: debhelper-compat (= 12),
               dh-python,
               libjs-bootstrap,
               libjs-excanvas,
               libjs-jquery,
               libjs-jquery-flot (>= 0.8.2),
               libjs-jquery-typeahead,
               node-uglify,
               po-debconf,
               python3,
               python3-setuptools (>= 3),
               python3-sphinx (>= 1.4),
               python3-sphinx-bootstrap-theme,
               python3-yaml
X-Python3-Version: >=3.6
Standards-Version: 4.2.1
Homepage: https://www.lavasoftware.org/
Vcs-Git: https://git.lavasoftware.org/lava/lava.git
Vcs-Browser: https://git.lavasoftware.org/lava/lava

Package: lava-dispatcher
Architecture: all
Depends: file,
         lava-common (= ${binary:Version}),
         lava-dispatcher-host (= ${binary:Version}),
         systemd-sysv,
         tar (>= 1.27),
         ${misc:Depends},
         ${python3:Depends}
Multi-Arch: foreign
Recommends: bridge-utils,
            debootstrap (>= 1.0.86),
            dfu-util,
            git,
            libguestfs-tools (>= 1.32.7),
            lxc (>= 1:2.0.7),
            nfs-kernel-server,
            ntp,
            openbsd-inetd,
            qemu-system-arm (>= 2.8.0),
            qemu-system-x86 (>= 2.8.0),
            rpcbind,
            rsync,
            ser2net,
            sudo,
            telnet,
            tftpd-hpa,
            u-boot-tools,
            unzip,
            xz-utils,
            zstd
Suggests: apache2,
          docker.io,
          img2simg,
          simg2img
Description: Linaro Automated Validation Architecture dispatcher
 LAVA is a continuous integration system for deploying operating
 systems onto physical and virtual hardware for running tests.
 Tests can be simple boot testing, bootloader testing and system
 level testing, although extra hardware may be required for some
 system tests. Results are tracked over time and data can be
 exported for further analysis.
 .
 This package provides lava-dispatcher to dispatch
 LAVA jobs to configured devices, for Python3 only.
 .
 A range of devices are supported for ARM and
 x86 architectures.

Package: lava-dispatcher-host
Architecture: all
Depends: lava-common (= ${binary:Version}),
         python3,
         python3-requests,
         python3-pyudev,
         ${misc:Depends},
         ${python3:Depends}
Multi-Arch: foreign
Suggests: udev
Description: LAVA dispatcher host tools
 LAVA is a continuous integration system for deploying operating
 systems onto physical and virtual hardware for running tests.
 Tests can be simple boot testing, bootloader testing and system
 level testing, although extra hardware may be required for some
 system tests. Results are tracked over time and data can be
 exported for further analysis.
 .
 This package provides tools needed on a host system to be used with
 container-related jobs. This package must be installed on a host
 system when lava-dispatcher runs inside a container on that host.

Package: lava-server
Architecture: all
Pre-Depends: debconf | debconf-2.0
Depends: adduser,
         apache2,
         gunicorn (>= 19.9.0-4) | gunicorn3,
         lava-common (= ${binary:Version}),
         lava-server-doc (= ${binary:Version}),
         libjs-bootstrap,
         libjs-excanvas,
         libjs-jquery,
         libjs-jquery-flot (>=0.8.2),
         libjs-jquery-typeahead,
         postgresql,
         postgresql-client,
         postgresql-common,
         systemd-sysv,
         ${misc:Depends},
         ${python3:Depends}
Recommends: lava-coordinator (= ${binary:Version}),
            lava-dispatcher (= ${binary:Version}),
            ntp,
            openssh-client,
Suggests: lavacli
Description: Linaro Automated Validation Architecture server
 LAVA is a continuous integration system for deploying operating
 systems onto physical and virtual hardware for running tests.
 Tests can be simple boot testing, bootloader testing and system
 level testing. Extra hardware may be required for some
 system tests. Results are tracked over time and data can be
 exported for further analysis.
 .
 This package provides the Apache and WSGI configuration and LAVA
 support files to run the validation server on the local Apache
 instance as a lava-server virtual host as well as the scheduler
 and dispatcher.
 .
 This package no longer supports configuration as a
 remote worker and needs to be removed from existing workers.
 Workers must only install lava-dispatcher.
 .
 This package no longer supports Python2.

Package: lava-common
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends}
Description: Linaro Automated Validation Architecture common
 LAVA is a continuous integration system for deploying operating
 systems onto physical and virtual hardware for running tests.
 Tests can be simple boot testing, bootloader testing and system
 level testing, although extra hardware may be required for some
 system tests. Results are tracked over time and data can be
 exported for further analysis.
 .
 This package contains common Python code to support lava-server
 and lava-dispatcher.

Package: lava
Architecture: all
Section: metapackages
Depends: bridge-utils,
         debootstrap (>= 1.0.86~),
         lava-coordinator (= ${binary:Version}),
         lava-dev (= ${binary:Version}),
         lava-dispatcher (= ${binary:Version}),
         lava-server (= ${binary:Version}),
         lava-server-doc (= ${binary:Version}),
         lavacli,
         lxc (>= 1:2.0.6),
         ntp | ntpdate | chrony,
         openssh-client,
         rsync,
         sudo,
         telnet,
         tftpd-hpa,
         ${misc:Depends}
Recommends: docker.io,
            img2simg,
            python3-docker,
            schroot,
            simg2img
Description: Linaro Automated Validation Architecture metapackage
 LAVA is a continuous integration system for deploying operating
 systems onto physical and virtual hardware for running tests.
 Tests can be simple boot testing, bootloader testing and system
 level testing, although extra hardware may be required for some
 system tests. Results are tracked over time and data can be
 exported for further analysis.
 .
 This metapackage brings in all LAVA components on a single
 machine. Some suggested packages may not be available for all
 architectures.

Package: lava-lxc-mocker
Architecture: all
Depends: ${misc:Depends}
Conflicts: lxc
Provides: lxc
Replaces: lxc
Description: Linaro Automated Validation Architecture LXC Mocker
 LAVA is a continuous integration system for deploying operating
 systems onto physical and virtual hardware for running tests.
 Tests can be simple boot testing, bootloader testing and system
 level testing, although extra hardware may be required for some
 system tests. Results are tracked over time and data can be
 exported for further analysis.
 .
 This package contains set of mocker scripts that mocks each of
 the lxc commands that LAVA uses. It does not support all commands
 and options that lxc provides, but just the ones that LAVA uses.
 Test jobs using LXC can then be replicated in Docker.

Package: lava-coordinator
Architecture: all
Depends: lava-common (= ${binary:Version}),
         python3,
         ${misc:Depends}
Description: LAVA coordinator daemon
 This package provides coordinator daemon to provide communication and
 synchronisation methods for test jobs running on multiple configured devices
 on instances of LAVA (Linaro Automated Validation Architecture).
 .
 One coordinator daemon can support more than one LAVA instance in a single
 lab.

Package: lava-dev
Architecture: all
Section: devel
Depends: build-essential,
         ca-certificates,
         debhelper (>= 9.20160709),
         debootstrap (>= 1.0.86),
         devscripts,
         dh-python,
         docbook-xsl,
         dpkg-dev,
         fakeroot,
         git,
         libdistro-info-perl,
         libjs-bootstrap,
         libjs-excanvas,
         libjs-jquery,
         libjs-jquery-flot (>= 0.8.2),
         libjs-jquery-typeahead,
         node-uglify,
         pep8 | python3-pep8,
         python3-configobj,
         python3-guestfs,
         python3-magic,
         python3-netifaces,
         python3-pexpect (>= 4.2),
         python3-pymongo,
         python3-pytest,
         python3-pytest-django,
         python3-pyudev,
         python3-requests,
         python3-setuptools,
         python3-sphinx (>= 1.4),
         python3-sphinx-bootstrap-theme,
         python3-tz,
         python3-voluptuous (>= 0.8.8),
         python3-yaml,
         python3-zmq,
         python3:any,
         xsltproc,
         ${misc:Depends},
         ${python3:Depends}
Recommends: img2simg,
            lxc,
            nfs-kernel-server,
            python3-django-extensions,
            python3-pydot,
            python3-pytest-cov,
            rpcbind,
            sbuild,
            simg2img,
            telnet,
            tftpd-hpa,
            u-boot-tools
Suggests: black,
          python3-bandit,
          python3-django-debug-toolbar,
          radon
Description: Linaro Automated Validation Architecture developer support
 LAVA is a continuous integration system for deploying operating
 systems onto physical and virtual hardware for running tests.
 .
 This package provides a helper script to build LAVA packages
 from local git working copies and support for running the
 LAVA unit tests locally, using Python3.

Package: lava-server-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Description: Linaro Automated Validation Architecture documentation
 LAVA is a continuous integration system for deploying operating
 systems onto physical and virtual hardware for running tests.
 Tests can be simple boot testing, bootloader testing and system
 level testing, although extra hardware may be required for some
 system tests. Results are tracked over time and data can be
 exported for further analysis.
 .
 This package contains an offline copy of the LAVA
 Manual which is also available on each instance running LAVA
 server.
 .
  - an overview of LAVA
  - help on installing and configuring LAVA
  - test developer guide to writing LAVA tests
  - use cases and examples
  - administrator guide for managing a LAVA lab
  - developer guide

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Prevent setuptools/distribute from accessing the internet.
export http_proxy = http://127.0.9.1:9

include /usr/share/dpkg/pkg-info.mk

export BUILD_DATE=$(shell LC_ALL=C date -u "+%B %d, %Y" -d @"$(SOURCE_DATE_EPOCH)")

# This has to be exported to make some magic below work.
export DH_OPTIONS

export PYBUILD_DISABLE=test/python3

PYTHONDIR=/usr/lib/python3/dist-packages/

PYTHON:=$(shell py3versions -r)
install_dir=$(call py_libdir, $(PYTHON))

%:
	dh $@ --with sphinxdoc,python3 --buildsystem=pybuild

override_dh_python3:
	./share/requires.py --distribution debian --suite $(DEB_DISTRIBUTION) --package lava-dispatcher > dispatcher-requirements.txt
	./share/requires.py --distribution debian --suite $(DEB_DISTRIBUTION) --package lava-server > server-requirements.txt
	./share/requires.py --distribution debian --suite $(DEB_DISTRIBUTION) --package lava-common > common-requirements.txt
	dh_python3 -p lava-dispatcher --shebang=/usr/bin/python3 --requires=dispatcher-requirements.txt
	dh_python3 -p lava-server --shebang=/usr/bin/python3 --requires=server-requirements.txt
	dh_python3 -p lava-common --shebang=/usr/bin/python3 --requires=common-requirements.txt

override_dh_auto_build:
	make -C man/ man SPHINXBUILD="/usr/share/sphinx/scripts/python3/sphinx-build" SPHINXOPTS="-D today=\"$(BUILD_DATE)\""
	make -C doc/v2/ html SPHINXBUILD="/usr/share/sphinx/scripts/python3/sphinx-build" SPHINXOPTS="-j 4 -D today=\"$(BUILD_DATE)\""
	$(RM) doc/v2/_build/html/objects.inv
	make -C man/ man SPHINXBUILD="/usr/share/sphinx/scripts/python3/sphinx-build" SPHINXOPTS="-j 4 -D today=\"$(BUILD_DATE)\""

override_dh_auto_install:
	find . -path '*/__pycache__/*' -delete
	find . -type d -name '__pycache__' -empty -delete
	# handle man pages
	dh_installman -plava-dispatcher man/_build/man/lava-run.1
	dh_installman -plava-dispatcher man/_build/man/lava-worker.8
	dh_installman -plava-lxc-mocker man/_build/man/lava-lxc-mocker.7
	dh_installman -plava-lxc-mocker man/_build/man/lxc-attach.1
	dh_installman -plava-lxc-mocker man/_build/man/lxc-create.1
	dh_installman -plava-lxc-mocker man/_build/man/lxc-destroy.1
	dh_installman -plava-lxc-mocker man/_build/man/lxc-device.1
	dh_installman -plava-lxc-mocker man/_build/man/lxc-info.1
	dh_installman -plava-lxc-mocker man/_build/man/lxc-start.1
	dh_installman -plava-lxc-mocker man/_build/man/lxc-stop.1
	dh_installman -plava-server man/_build/man/lava-server.1
	# use setup.py
	python3 setup.py install --root=$(CURDIR)/debian/lava-common/ --no-compile --install-layout=deb lava-common
	rm -rf $(CURDIR)/build
	python3 setup.py install --root=$(CURDIR)/debian/lava-coordinator/ --no-compile --install-layout=deb lava-coordinator
	rm -rf $(CURDIR)/build
	python3 setup.py install --root=$(CURDIR)/debian/lava-dispatcher/ --no-compile --install-layout=deb lava-dispatcher
	rm -rf $(CURDIR)/build
	python3 setup.py install --root=$(CURDIR)/debian/lava-dispatcher-host/ --no-compile --install-layout=deb lava-dispatcher-host
	rm -rf $(CURDIR)/build
	python3 setup.py install --root=$(CURDIR)/debian/lava-server/ --no-compile --install-layout=deb lava-server
	rm -rf $(CURDIR)/build
	# handle embedded JS
	python3 ./share/javascript.py -f ./share/javascript.yaml --remove
	$(RM) $(CURDIR)/debian/lava-server/usr/lib/python3/dist-packages/lava_results_app/static/lava_results_app/js/jquery.flot.canvas.js

override_dh_fixperms-arch:
	dh_fixperms -X debian/lava-dispatcher/usr/lib/python3/dist-packages/lava_dispatcher/dynamic_vm_keys/lava
	# ssh connections use a shared private key - use the same location for debian & ubuntu
	chmod 0600 debian/lava-dispatcher/usr/lib/python3/dist-packages/lava_dispatcher/dynamic_vm_keys/lava
	chmod 0644 debian/lava-dispatcher/usr/lib/python3/dist-packages/lava_dispatcher/dynamic_vm_keys/lava.pub

override_dh_installinit:
	dh_installinit -Nlava-server

override_dh_installsystemd:
	dh_installsystemd -Xlava-celery-worker.service -Xlava-docker-worker.service

override_dh_compress:
	dh_compress -X.yaml
	$(RM) -r debian/lava/usr/lib
	$(RM) -r debian/lava/usr/bin

override_dh_auto_clean:
	python3 setup.py clean -a
	find . -path '*/__pycache__/*' -delete
	$(RM) -r lava.egg-info .idea/ build/
	$(RM) -r .eggs/ versiontools-*.egg/ doc/build/ doc/html/
	find . -type d -name '__pycache__' -empty -delete
	$(RM) -r dist/
	$(RM) debian/*.service
	$(RM) common-requirements.txt dispatcher-requirements.txt server-requirements.txt
	[ ! -f doc/v2/Makefile ] || make -C doc/v2/ clean
	[ ! -f man/Makefile ] || make -C man/ clean

## lava 2022.01.3

=== debian/changelog ===
lava (2022.01.3-1) unstable; urgency=medium

  [ Remi Duraffort ]
  * LAVA Software 2022.01.3 release

  [ Antonio Terceiro ]
  * debian: don't depend on or recommend ntp-related packages
  * debian/rules: ensure services are restarted on upgrades
  * autopkgtest: install qemu-system-arm
  * Apply upstream patch to fix running testsuite under autopkgtest

 -- Antonio Terceiro <terceiro@debian.org>  Thu, 03 Feb 2022 15:21:15 -0300

lava (2022.01.2-1) unstable; urgency=medium

  * LAVA Software 2022.01.2 release

 --  <remi.duraffort@linaro.org>  Wed, 19 Jan 2022 17:11:38 +0100

lava (2022.01.1-1) unstable; urgency=medium

  * LAVA Software 2022.01.1 release

 --  <remi.duraffort@linaro.org>  Tue, 18 Jan 2022 16:18:52 +0100

lava (2022.01-1) unstable; urgency=medium

  * LAVA Software 2022.01 release

  [ Antonio Terceiro ]
  * [b3ef53b98] ci: debian: check dependencies for lava-dispatcher-hosts as well
  * [180cb3c14] lava_dispatcher_host: add support for docker device sharing under cgroups v2
  * [c3cbe547a] lava-dispatcher-host: move device sharing to a daemon

 --  <remi.duraffort@linaro.org>  Tue, 18 Jan 2022 15:10:15 +0100

lava (2021.11-1) unstable; urgency=medium

  * LAVA Software 2021.11 release

 -- Remi Duraffort <remi.duraffort@linaro.org>  Fri, 26 Nov 2021 13:53:10 +0100

lava (2021.10-1) unstable; urgency=medium

  * LAVA Software 2021.10 release

 -- Remi Duraffort <remi.duraffort@linaro.org>  Thu, 28 Oct 2021 14:14:14 +0200

lava (2021.09-1) unstable; urgency=medium

  * LAVA Software 2021.09 release

  [ Stevan Radaković ]
  * [34b9e247] Merge branch 'http-download-timeout' into 'master'

 -- Stevan Radaković <stevan.radakovic@linaro.org>  Tue, 28 Sep 2021 14:53:21 +0100

lava (2021.08-1) unstable; urgency=medium

  * LAVA Software 2021.08 release

  [ Rémi Duraffort ]
  * [3592a042] Merge branch 'issue-501' into 'master'

 -- Stevan Radaković <stevan.radakovic@linaro.org>  Tue, 31 Aug 2021 13:11:21 +0100

lava (2021.05-1) unstable; urgency=medium

  * LAVA Software 2021.05 release

  [ Hiraku Toyooka ]
  * [fa2dcbbe] dispatcher: device-types: fix broken xilinx-zcu102 device-type

 -- Stevan Radaković <stevan.radakovic@linaro.org>  Thu, 27 May 2021 16:08:21 +0100

lava (2021.04.post1-1) unstable; urgency=medium

  * Fix
  a002b8d4 debian: fix dependency on python3-django-environ
  3cf74beb scheduler: use token management for secrets dictionary
  * Update
  276afa93 docker: install qemu-system-sparc

 -- Stevan Radaković <stevan.radakovic@linaro.org>  Tue, 04 May 2021 09:34:21 +0100

lava (2021.04-1) unstable; urgency=medium

  * LAVA Software 2021.04 release

  [ Antonio Terceiro ]
  * [62e0369c8] dispatcher: fvp: simplify getting FastModel version

 -- Stevan Radaković <stevan.radakovic@linaro.org>  Fri, 27 Apr 2021 12:48:21 +0100

lava (2021.03.post1-1) unstable; urgency=medium

  * Security hotfix
  2bdbd462 Fix authorization issues in REST API.
  * Update
  eed28e69 fvp: allow to specify the docker network
  49676b29 Add namespace to a feedback channel.
  dfd24bad doc: authentication: add redirect URI to Gitlab provider

 -- Stevan Radakovic <stevan.radakovic@linaro.org>  Mon, 22 Mar 2021 13:13:32 +0100

lava (2021.03-1) unstable; urgency=medium

  * LAVA Software 2021.03 release

  [ Antonio Terceiro ]
  * [43ea48e11] debian: move possible celery backends to Suggests:

 -- Stevan Radaković <stevan.radakovic@linaro.org>  Fri, 12 Mar 2021 11:28:21 +0100

lava (2021.01-1) unstable; urgency=medium

  [ Antonio Terceiro ]
  * [ac4f863fd] autopkgtest: management: run from $HOME

 -- Stevan Radakovic <stevan.radakovic@linaro.org>  Tue, 26 Jan 2021 13:59:07 +0100

=== debian/tests/control ===
Tests: management
Depends: postgresql, apache2, lava-dispatcher, lava-server
Restrictions: allow-stderr, needs-root, isolation-container

Tests: testsuite
Depends: dh-python,
         git,
         lava-coordinator,
         lava-dispatcher,
         lava-server,
         lxc,
         nfs-kernel-server,
         postgresql,
         python3-pymongo,
         python3-pytest,
         python3-pytest-django,
         python3-pytest-mock,
         python3-setuptools (>= 3),
         python3-sphinx (>= 1.4),
         python3-tz,
         python3-yaml,
         qemu-system-arm,
         qemu-system-x86,
         schroot,
         telnet,
         tftpd-hpa,
         u-boot-tools,
         @builddeps@
Restrictions: allow-stderr, needs-root

Test-Command: python3 -c 'from lava_common import *'
Depends: lava-common
Features: test-name=lava-common
Restrictions: allow-stderr, superficial

Tests: lava-dispatcher-host
Depends: lava-dispatcher-host
Restrictions: skippable

Tests: lava-coordinator
Depends: lava-coordinator
Restrictions: isolation-container

## lava 2022.10

=== debian/changelog ===
lava (2022.10-1) unstable; urgency=medium

  [ Rémi Duraffort ]
  * LAVA Software 2022.10 release
    - Fixes remote code execution [CVE-2022-42902] (Closes: #1021737)
    - Fixes startup with Django 3.2 (Closes: #994258)

  [ Antonio Terceiro ]
  * Drop patches, already applied upstream.

 -- Rémi Duraffort <remi.duraffort@linaro.org>  Tue, 11 Oct 2022 11:44:37 +0200

lava (2022.08-1) unstable; urgency=medium

  * LAVA Software 2022.08 release

  [ Antonio Terceiro ]
  * [29478ada2] debian/control: add Ubuntu packages

 -- Rémi Duraffort <remi.duraffort@linaro.org>  Fri, 12 Aug 2022 10:26:43 +0200

lava (2022.06-1) unstable; urgency=medium

  * LAVA Software 2022.06 release

 -- Rémi Duraffort <remi.duraffort@linaro.org>  Thu, 30 Jun 2022 10:59:00 +0200

lava (2022.05-1) unstable; urgency=medium

  * LAVA Software 2022.05 release

  [ Chase Qi ]
  * [55b668402] lava-dispatcher-host: support to install on ubuntu focal

 -- Rémi Duraffort <remi.duraffort@linaro.org>  Mon, 30 May 2022 16:48:01 +0200

lava (2022.04-1) unstable; urgency=medium

  * LAVA Software 2022.04 release

  [ Rémi Duraffort ]
  * [4403c359d] lava-docker-worker: fix some bugs found on staging

 -- Rémi Duraffort <remi.duraffort@linaro.org>  Thu, 21 Apr 2022 11:29:38 +0200

lava (2022.03-1) unstable; urgency=medium

  * LAVA Software 2022.03 release

 -- Rémi Duraffort <remi.duraffort@linaro.org>  Mon, 28 Mar 2022 16:40:18 +0200

lava (2022.02-1) unstable; urgency=medium

  * LAVA Software 2022.02 release

  [ Antonio Terceiro ]
  * [12bf01a17] debian/rules: ensure services are restarted on upgrades
  * [5cfda2e7a] autopkgtest: install qemu-system-arm
  * [7bd2397bc] autopkgtest: testsuite: add dependency on lava-dispatcher-host

 -- Rémi Duraffort <remi.duraffort@linaro.org>  Tue, 01 Mar 2022 10:55:30 +0100

lava (2022.01.3-3) unstable; urgency=medium

  * Skip BPF test when running testsuite on containers. This fixes the
    autopkgtest failures on Debian CI.

 -- Antonio Terceiro <terceiro@debian.org>  Mon, 07 Feb 2022 11:08:02 -0300

lava (2022.01.3-2) unstable; urgency=medium

  * autopkgtest: testsuite: add dependency on lava-dispatcher-host

 -- Antonio Terceiro <terceiro@debian.org>  Fri, 04 Feb 2022 14:46:39 -0300

## lava 2023.01

=== requirements.txt ===
# DO NOT EDIT
# content is managed via ./share/requires.py

=== doc/content/requirements.txt ===
mkdocs-material
pymdown-extensions

=== debian/changelog ===
lava (2023.01-2) unstable; urgency=medium

  * autopkgtest: restrict to amd64 and arm64

 -- Antonio Terceiro <terceiro@debian.org>  Mon, 23 Jan 2023 16:32:59 -0300

lava (2023.01-1) unstable; urgency=medium

  * LAVA Software 2023.01 release
    - Adds alternative dependency on telnet-client (Closes: #1016849)
    - Includes fix for Code execution in jinja templates [CVE-2022-45132]
      (Closes: #1024428)
    - Includes fix for Recursive XML entity expansion [CVE-2022-44641]
      (Closes: #1024429)

  [ Antonio Terceiro ]
  * [c3eb0b19e] debian/tests/management: fix device management command

 -- Rémi Duraffort <remi.duraffort@linaro.org>  Thu, 19 Jan 2023 10:23:15 +0100

lava (2022.11-2) unstable; urgency=medium

  * LAVA Software 2022.11.1 release

 -- Stevan Radaković <stevan.radakovic@linaro.org>  Fri, 10 Nov 2022 12:19:32 +0200

lava (2022.11-1) unstable; urgency=medium

  * LAVA Software 2022.11 release

 -- Stevan Radaković <stevan.radakovic@linaro.org>  Fri, 04 Nov 2022 15:22:37 +0200

=== debian/control ===
--- 
+++ 
@@ -9,13 +9,13 @@
                libjs-bootstrap,
                libjs-excanvas,
                libjs-jquery,
-               libjs-jquery-flot (>= 0.8.2),
+               libjs-jquery-flot,
                libjs-jquery-typeahead,
-               node-uglify,
+               uglifyjs,
                po-debconf,
                python3,
-               python3-setuptools (>= 3),
-               python3-sphinx (>= 1.4),
+               python3-setuptools,
+               python3-sphinx,
                python3-sphinx-bootstrap-theme,
                python3-yaml
 X-Python3-Version: >=3.6
@@ -35,21 +35,20 @@
          ${python3:Depends}
 Multi-Arch: foreign
 Recommends: bridge-utils,
-            debootstrap (>= 1.0.86),
+            debootstrap,
             dfu-util,
             git,
-            libguestfs-tools (>= 1.32.7),
-            lxc (>= 1:2.0.7),
+            libguestfs-tools,
+            lxc | lava-lxc-mocker,
             nfs-kernel-server,
-            ntp,
             openbsd-inetd,
-            qemu-system-arm (>= 2.8.0),
-            qemu-system-x86 (>= 2.8.0),
+            qemu-system-arm,
+            qemu-system-x86,
             rpcbind,
             rsync,
             ser2net,
             sudo,
-            telnet,
+            telnet | telnet-client,
             tftpd-hpa,
             u-boot-tools,
             unzip,
@@ -76,7 +75,11 @@
 Package: lava-dispatcher-host
 Architecture: all
 Depends: lava-common (= ${binary:Version}),
+         base-files (<< 11.1) | python3-bpfcc (>= 0.21),
+         base-files (<< 11.1) | linux-headers-amd64 | linux-headers-arm64 | linux-headers-generic,
+         base-files (<< 11.1) | bpftool | linux-tools-common,
          python3,
+         python3-jinja2,
          python3-requests,
          python3-pyudev,
          ${misc:Depends},
@@ -99,26 +102,26 @@
 Architecture: all
 Pre-Depends: debconf | debconf-2.0
 Depends: adduser,
-         apache2,
          gunicorn (>= 19.9.0-4) | gunicorn3,
          lava-common (= ${binary:Version}),
          lava-server-doc (= ${binary:Version}),
          libjs-bootstrap,
          libjs-excanvas,
          libjs-jquery,
-         libjs-jquery-flot (>=0.8.2),
+         libjs-jquery-flot,
          libjs-jquery-typeahead,
-         postgresql,
          postgresql-client,
-         postgresql-common,
          systemd-sysv,
          ${misc:Depends},
          ${python3:Depends}
-Recommends: lava-coordinator (= ${binary:Version}),
+Recommends: apache2,
+            lava-coordinator (= ${binary:Version}),
             lava-dispatcher (= ${binary:Version}),
-            ntp,
             openssh-client,
-Suggests: lavacli
+            postgresql,
+            postgresql-common
+Suggests: lavacli,
+          rabbitmq-server | redis-server,
 Description: Linaro Automated Validation Architecture server
  LAVA is a continuous integration system for deploying operating
  systems onto physical and virtual hardware for running tests.
@@ -157,19 +160,17 @@
 Architecture: all
 Section: metapackages
 Depends: bridge-utils,
-         debootstrap (>= 1.0.86~),
+         debootstrap,
          lava-coordinator (= ${binary:Version}),
          lava-dev (= ${binary:Version}),
          lava-dispatcher (= ${binary:Version}),
          lava-server (= ${binary:Version}),
          lava-server-doc (= ${binary:Version}),
          lavacli,
-         lxc (>= 1:2.0.6),
-         ntp | ntpdate | chrony,
          openssh-client,
          rsync,
          sudo,
-         telnet,
+         telnet | telnet-client,
          tftpd-hpa,
          ${misc:Depends}
 Recommends: docker.io,
@@ -193,7 +194,6 @@
 Architecture: all
 Depends: ${misc:Depends}
 Conflicts: lxc
-Provides: lxc
 Replaces: lxc
 Description: Linaro Automated Validation Architecture LXC Mocker
  LAVA is a continuous integration system for deploying operating
@@ -226,8 +226,8 @@
 Section: devel
 Depends: build-essential,
          ca-certificates,
-         debhelper (>= 9.20160709),
-         debootstrap (>= 1.0.86),
+         debhelper (>= 12),
+         debootstrap,
          devscripts,
          dh-python,
          docbook-xsl,
@@ -238,25 +238,25 @@
          libjs-bootstrap,
          libjs-excanvas,
          libjs-jquery,
-         libjs-jquery-flot (>= 0.8.2),
+         libjs-jquery-flot,
          libjs-jquery-typeahead,
-         node-uglify,
+         uglifyjs,
          pep8 | python3-pep8,
          python3-configobj,
          python3-guestfs,
          python3-magic,
          python3-netifaces,
-         python3-pexpect (>= 4.2),
+         python3-pexpect,
          python3-pymongo,
          python3-pytest,
          python3-pytest-django,
          python3-pyudev,
          python3-requests,
          python3-setuptools,
-         python3-sphinx (>= 1.4),
+         python3-sphinx,
          python3-sphinx-bootstrap-theme,
          python3-tz,
-         python3-voluptuous (>= 0.8.8),
+         python3-voluptuous,
          python3-yaml,
          python3-zmq,
          python3:any,
@@ -264,7 +264,7 @@
          ${misc:Depends},
          ${python3:Depends}
 Recommends: img2simg,
-            lxc,
+            lxc | lava-lxc-mocker,
             nfs-kernel-server,
             python3-django-extensions,
             python3-pydot,
@@ -272,7 +272,7 @@
             rpcbind,
             sbuild,
             simg2img,
-            telnet,
+            telnet | telnet-client,
             tftpd-hpa,
             u-boot-tools
 Suggests: black,

=== debian/tests/control ===
--- 
+++ 
@@ -1,12 +1,14 @@
 Tests: management
 Depends: postgresql, apache2, lava-dispatcher, lava-server
 Restrictions: allow-stderr, needs-root, isolation-container
+Architecture: amd64 arm64
 
 Tests: testsuite
 Depends: dh-python,
          git,
          lava-coordinator,
          lava-dispatcher,
+         lava-dispatcher-host,
          lava-server,
          lxc,
          nfs-kernel-server,
@@ -27,16 +29,20 @@
          u-boot-tools,
          @builddeps@
 Restrictions: allow-stderr, needs-root
+Architecture: amd64 arm64
 
 Test-Command: python3 -c 'from lava_common import *'
 Depends: lava-common
 Features: test-name=lava-common
 Restrictions: allow-stderr, superficial
+Architecture: amd64 arm64
 
 Tests: lava-dispatcher-host
 Depends: lava-dispatcher-host
 Restrictions: skippable
+Architecture: amd64 arm64
 
 Tests: lava-coordinator
 Depends: lava-coordinator
 Restrictions: isolation-container
+Architecture: amd64 arm64

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# https://git.lavasoftware.org/codehelp/lava-test/-/archive/2018.10/lava-test-2018.10.tar.gz

opts=filenamemangle=s/.*\/archive\/(\d\S+)\/lava.*\.tar\.gz/lava-$1\.tar\.gz/g \
  https://git.lavasoftware.org/lava/lava/tags?sort=updated_desc .*/archive/(\d\S+)/.*\.tar\.gz.*
